
% F16 sim plots
close all
sim_length=60;

%% longitudinal motion control

% disturbance of angle of attack - wind gust!
% figure
% plot(alpha_disturbance.time, alpha_disturbance.signals.values);
% title('Angle of attack (\alpha) disturbance');
% % xlim([0,30]);
% % ylim([-0.5,2.5]);
% xlabel('time [s]');
% ylabel('\Delta_{\alpha}');
% grid

% positions/outer loop 
alt_refTraj = zeros(length(positions_ned.time));
for i=1 : length(Altitude_refTrajectory.signals.values(:,:,:))
alt_refTraj(i)=Altitude_refTrajectory.signals.values(:,:,i);
end
figure
subplot(2,1,1);
plot(positions_ned.time, positions_ned.signals(1,3).values,...
     Altitude_refTrajectory.time, alt_refTraj, '--')
title('Altitude control');
xlabel('time [s]');
ylabel('altitude [ft]');
xlim([0,sim_length]);
ylim([19500,20500]);
grid

subplot(2,1,2);
plot(gamma_setpoints.time, gamma_setpoints.signals.values)
xlabel('time [s]');
ylabel('\gamma: flight path reference [deg]');
xlim([0,sim_length]);
ylim([-5,15]);
grid

% Attitude/inner loop
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,2).values)
title('Pitch attitude and Angle of attack responses');
xlim([0,sim_length]);
ylim([-30,30]);
xlabel('time [s]');
ylabel('\theta [deg]');
grid

subplot(2,1,2);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,2).values)
xlabel('time [s]');
ylabel('\alpha [deg]');
xlim([0,sim_length]);
ylim([-30,30]);
grid

% Speed and rotational rates 
figure
subplot(2,1,1);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,1).values)
title('Total speed V_T and Pitch rate Q');
xlabel('time [s]');
ylabel('V_T [ft/s]');
xlim([0,sim_length]);
ylim([640,720]);
grid

subplot(2,1,2);
plot(rotational_rates_pqr.time, rotational_rates_pqr.signals(1,2).values)
ylim([-20,20]);
xlabel('time [s]');
ylabel('Q [deg/s]');
xlim([0,sim_length]);
grid

% Controls
figure
subplot(2,1,1);
plot(ElevatorControl.time, ElevatorControl.signals.values)
title('Longitudinal control effectors');
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('elevator input [deg]');
% ylim([-15,5]);
grid

subplot(2,1,2);
plot(ThrustControl.time, ThrustControl.signals.values)
xlim([0,sim_length]);
ylim([1000,19000]);
xlabel('time [s]');
ylabel('thrust input [lbs]');
grid


% % tracking
% figure
% % subplot(2,1,1);
% plot(attitude_phi_theta_psi.time, (attitude_phi_theta_psi.signals(1,2).values - vel_alpha_beta.signals(1,2).values), ...
%      gamma_setpoints.time, gamma_setpoints.signals.values, '--')
% title('Flight path tracking');
% xlim([0,sim_length]);
% ylim([-30,30]);
% xlabel('time [s]');
% ylabel('\theta [deg]');
% grid

% subplot(2,1,2);
% plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,2).values)
% xlabel('time [s]');
% ylabel('\alpha [deg]');
% xlim([0,sim_length]);
% ylim([-30,30]);
% grid
% 
% plot(gamma_setpoints.time, gamma_setpoints.signals.values)
% xlabel('time [s]');
% ylabel('\gamma: flight path reference [deg]');
% xlim([0,sim_length]);
% grid


%% lateral motion control

% disturbance of altitude - turbulence!
% figure
% plot(altitude_disturbance.time, altitude_disturbance.signals.values);
% title('Altitude disturbance');
% % xlim([0,30]);
% % ylim([-0.5,2.5]);
% xlabel('time [s]');
% ylabel('\Delta_h');
% grid

% outer loop
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,3).values,...
     Heading_refTrajectory.time, Heading_refTrajectory.signals.values, '--')
title('Heading control');
xlabel('time [s]');
ylabel('\psi: heading [deg]');
xlim([0,sim_length]);
ylim([0,30]);
grid

subplot(2,1,2);
plot(phi_setpoints.time, phi_setpoints.signals.values) % change from theta_setpoints1
% plot(theta_setpoints1.time, theta_setpoints1.signals.values) % change to phi_setpoints
xlabel('time [s]');
ylabel('\phi_r: roll reference [deg]');
xlim([0,sim_length]);
ylim([-100,100]);
grid

% Attitude/inner loop
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,1).values)
title('Roll attitude and Sideslip responses');
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('\phi [deg]');
ylim([-100,100]);
grid

subplot(2,1,2);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,3).values)
xlabel('time [s]');
ylabel('\beta [deg]');
xlim([0,sim_length]);
ylim([-4,2]);
grid

% Speed and rotational rates 
figure
subplot(2,1,1);
plot(rotational_rates_pqr.time, rotational_rates_pqr.signals(1,1).values)
title('Lateral rotational rates');
xlabel('time [s]');
ylabel('P: roll rate [deg/s]');
xlim([0,sim_length]);
ylim([-50,50]);
grid

subplot(2,1,2);
plot(rotational_rates_pqr.time, rotational_rates_pqr.signals(1,3).values)
% ylim([-1,1]);
xlabel('time [s]');
ylabel('R: yaw rate [deg/s]');
xlim([0,sim_length]);
ylim([-15,5]);
grid

% Controls
figure
subplot(2,1,1);
plot(AileronControl.time, AileronControl.signals.values)
title('Lateral control effectors');
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('aileron input [deg]');
ylim([-10,10]);
grid

subplot(2,1,2);
plot(RudderControl.time, RudderControl.signals.values)
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('rudder input [deg]');
ylim([-10,5]);
grid

% % roll tracking
% figure
% plot(phi_setpoints.time, phi_setpoints.signals.values, '--',...
%      attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,1).values)
% xlabel('time [s]');
% ylabel('\phi [deg]');
% xlim([0,sim_length]);
% ylim([-100,100]);
% grid

% % Attitude/inner loop
% figure
% subplot(2,1,1);
% plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,1).values)
% title('Roll attitude and Sideslip responses');
% xlim([0,sim_length]);
% xlabel('time [s]');
% ylabel('\phi [deg]');
% ylim([-100,100]);
% grid
% % 
