
% F16 sim plots
close all
sim_length=60;

%% longitudinal motion control

% disturbance of angle of attack - wind gust!
% figure
% plot(alpha_disturbance.time, alpha_disturbance.signals.values);
% title('Angle of attack (\alpha) disturbance');
% % xlim([0,30]);
% % ylim([-0.5,2.5]);
% xlabel('time [s]');
% ylabel('\Delta_{\alpha}');
% grid

% positions/outer loop 
tn=60;
alt_refTraj = zeros(tn);
for i=1 : length(Altitude_refTrajectory.signals.values(:,:,:))
alt_refTraj(i)=Altitude_refTrajectory.signals.values(:,:,i);
end
figure
subplot(2,1,1);
plot(positions_ned.time(1:tn), positions_ned.signals(1,3).values(1:tn),'-',...
     positions_ned_FDI_adj.time(1:tn), positions_ned_FDI_adj.signals(1,3).values((1:tn)), '--')
%      Altitude_refTrajectory.time(1:tn), alt_refTraj(1:tn), '-.')
title('Altitude control');
xlabel('time [s]');
ylabel('altitude [ft]');
xlim([0,sim_length]);
ylim([19500,20500]);
grid

subplot(2,1,2);
plot(gamma_setpoints.time, gamma_setpoints.signals.values,'-',...
     gamma_setpoints_FDI_adj.time, gamma_setpoints_FDI_adj.signals.values, '--')
xlabel('time [s]');
ylabel('\gamma: flight path reference [deg]');
xlim([0,sim_length]);
grid

% Attitude/inner loop
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,2).values,'-',...
     attitude_phi_theta_psi_FDI_adj.time, attitude_phi_theta_psi_FDI_adj.signals(1,2).values, '--')
title('Pitch attitude and Angle of attack responses');
xlim([0,sim_length]);
ylim([-30,30]);
xlabel('time [s]');
ylabel('\theta [deg]');
grid

subplot(2,1,2);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,2).values,'-',...
     vel_alpha_beta_FDI_adj.time, vel_alpha_beta_FDI_adj.signals(1,2).values, '--')
xlabel('time [s]');
ylabel('\alpha [deg]');
xlim([0,sim_length]);
ylim([-30,30]);
grid

% Speed and rotational rates 
figure
subplot(2,1,1);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,1).values,'-',...
     vel_alpha_beta_FDI_adj.time, vel_alpha_beta_FDI_adj.signals(1,1).values, '--')
title('Total speed V_T and Pitch rate Q');
xlabel('time [s]');
ylabel('V_T [ft/s]');
xlim([0,sim_length]);
grid

subplot(2,1,2);
plot(rotational_rates_pqr.time, rotational_rates_pqr.signals(1,2).values,'-',...
     rotational_rates_pqr_FDI_adj.time, rotational_rates_pqr_FDI_adj.signals(1,2).values, '--')
% ylim([-1,1]);
xlabel('time [s]');
ylabel('Q [deg/s]');
xlim([0,sim_length]);
grid

% Controls
figure
subplot(2,1,1);
plot(ElevatorControl.time, ElevatorControl.signals.values,'-',...
     ElevatorControl_FDI_adj.time, ElevatorControl_FDI_adj.signals.values, '--')
title('Longitudinal control effectors');
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('elevator input [deg]');
grid

subplot(2,1,2);
plot(ThrustControl.time, ThrustControl.signals.values,'-',...
     ThrustControl_FDI_adj.time, ThrustControl_FDI_adj.signals.values, '--')
xlim([0,sim_length]);
ylim([1000,19000]);
xlabel('time [s]');
ylabel('thrust input [lbs]');
grid

%% lateral motion control

% disturbance of altitude - turbulence!
% figure
% plot(altitude_disturbance.time, altitude_disturbance.signals.values);
% title('Altitude disturbance');
% % xlim([0,30]);
% % ylim([-0.5,2.5]);
% xlabel('time [s]');
% ylabel('\Delta_h');
% grid

% outer loop
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,3).values,'-',...
     attitude_phi_theta_psi_FDI_adj.time, attitude_phi_theta_psi_FDI_adj.signals(1,3).values, '--')
%      Heading_refTrajectory.time, Heading_refTrajectory.signals.values, '-.')
title('Heading control');
xlabel('time [s]');
ylabel('\psi: heading [deg]');
xlim([0,sim_length]);
% ylim([-30,30]);
grid

subplot(2,1,2);
plot(phi_setpoints.time, phi_setpoints.signals.values,'-',...
     phi_setpoints_FDI_adj.time, phi_setpoints_FDI_adj.signals.values, '--') % change from theta_setpoints1
% plot(theta_setpoints1.time, theta_setpoints1.signals.values) % change to phi_setpoints
xlabel('time [s]');
ylabel('\phi_r: roll reference [deg]');
xlim([0,sim_length]);
grid

% Attitude/inner loop
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,1).values,'-',...
     attitude_phi_theta_psi_FDI_adj.time, attitude_phi_theta_psi_FDI_adj.signals(1,1).values, '--')
title('Roll attitude and Sideslip responses');
xlim([0,sim_length]);
% ylim([-30,30]);
xlabel('time [s]');
ylabel('\phi [deg]');
grid

subplot(2,1,2);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,3).values,'-',...
     vel_alpha_beta_FDI_adj.time, vel_alpha_beta_FDI_adj.signals(1,3).values, '--')
xlabel('time [s]');
ylabel('\beta [deg]');
xlim([0,sim_length]);
% ylim([-30,30]);
grid

% Speed and rotational rates 
figure
subplot(2,1,1);
plot(rotational_rates_pqr.time, rotational_rates_pqr.signals(1,1).values,'-',...
     rotational_rates_pqr_FDI_adj.time, rotational_rates_pqr_FDI_adj.signals(1,1).values, '--')
title('Lateral rotational rates');
xlabel('time [s]');
ylabel('P: roll rate [deg/s]');
xlim([0,sim_length]);
grid

subplot(2,1,2);
plot(rotational_rates_pqr.time, rotational_rates_pqr.signals(1,3).values,'-',...
     rotational_rates_pqr_FDI_adj.time, rotational_rates_pqr_FDI_adj.signals(1,3).values, '--')
% ylim([-1,1]);
xlabel('time [s]');
ylabel('R: yaw rate [deg/s]');
xlim([0,sim_length]);
grid

% Controls
figure
subplot(2,1,1);
plot(AileronControl.time, AileronControl.signals.values,'-',...
     AileronControl_FDI_adj.time, AileronControl_FDI_adj.signals.values, '--')
title('Lateral control effectors');
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('aileron input [deg]');
grid

subplot(2,1,2);
plot(RudderControl.time, RudderControl.signals.values,'-',...
     RudderControl_FDI_adj.time, RudderControl_FDI_adj.signals.values, '--')
xlim([0,sim_length]);
xlabel('time [s]');
ylabel('rudder input [deg]');
grid

