
% F16 sim plots
close all

% longitudinal stability

% disturbance of angle of attack
figure
plot(alpha_disturbance.time, alpha_disturbance.signals.values);
title('Angle of attack (\alpha) disturbance');
% xlim([0,30]);
% ylim([-0.5,2.5]);
xlabel('time [s]');
ylabel('\Delta_{\alpha}');
grid

% positions
figure
subplot(2,1,1);
plot(positions_ned.time, positions_ned.signals(1,1).values)
title('Longitudinal positions in NED');
xlabel('time [s]');
ylabel('npos [ft]');
grid

subplot(2,1,2);
plot(positions_ned.time, positions_ned.signals(1,3).values)
xlabel('time [s]');
ylabel('altitude [ft]');
grid

% Attitude
figure
subplot(2,1,1);
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,2).values)
title('Pitch NMPC Autopilot Response');
% xlim([0,30]);
% ylim([-5,30]);
xlabel('time [s]');
ylabel('\theta [deg]');
grid

subplot(2,1,2);
plot(ElevatorControl.time, ElevatorControl.signals.values)
% xlim([0,30]);
xlabel('time [s]');
ylabel('elevator input [deg]');
grid


% Wind/stability axes parameters 
figure
subplot(2,1,1);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,1).values)
title('Longitudinal wind/stability axes parameters');
xlabel('time [s]');
ylabel('Vel [ft/s]');
% xlim([0,30]);
grid

subplot(2,1,2);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,2).values)
xlabel('time [s]');
ylabel('\alpha [deg]');
% xlim([0,30]);
grid

% Rotational rates
figure
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,3).values)
title('Longitudinal rotational rates, q ');
% ylim([-1,1]);
xlabel('time [s]');
ylabel('q [deg/s]');
grid


