
close all;

alpha=[-10 -5 0 5 10 15 20 25 30 35 40 45];

% original F16 Cm table

Cm_25_=[ .205,  .168,  .186,  .196,  .213,  .251,  .245,  .238,  .252,  .231,  .198,  .192];
Cm_10_=[ .081,  .077,  .107,  .110,  .110,  .141,  .127,  .119,  .133,  .108,  .081,  .093];
Cm_0  =[-.046, -.020, -.009, -.005, -.006,  .010,  .006, -.001,  .014,   0.0, -.013,  .032];
Cm_10 =[-.174, -.145, -.121, -.127, -.129, -.102, -.097, -.113, -.087, -.084, -.069, -.006];
Cm_25 =[-.259, -.202, -.184, -.193, -.199, -.150, -.160, -.167, -.104, -.076, -.041, -.005];

% % Cm table shifted and adapted 
% Cm_25_=[ .186,  .196,  .213,  .251,  .245,  .238,  .252,  .231,  .198,  .192,  .193,  .194];
% Cm_10_=[ .107,  .110,  .110,  .141,  .127,  .119,  .119,  .108,  .081,  .093,  .094,  .095];
% Cm_0  =[-.009, -.005, -.006,  .014,  .012, -.011,  .010,   0.0, -.013,  .032,  .033,  .034];
% Cm_10 =[-.121, -.127, -.129, -.097, -.102, -.113, -.087, -.084, -.069, -.006, -.005, -.004];
% Cm_25 =[-.184, -.193, -.199, -.150, -.160, -.167, -.104, -.076, -.041, -.005, -.004, -.003];

alp = -10:45; % for interpolation
Cm = [ Cm_25_; Cm_10_; Cm_0; Cm_10; Cm_25 ];

figure
xy1=spline(alpha, Cm_25_, alp);
plot(alpha,Cm_25_,'*',alp,xy1);
xlim([-10,45]);
xlabel('\alpha [deg]');
% ylabel('Cm_{-25\circ}');
ylabel('Cm');
title('Cm_\alpha for \delta_e= -25\circ');
grid

% figure
% mesh(Cm);

figure
xy2=pchip(alpha, Cm_10_, alp);
plot(alpha,Cm_10_,'*',alp,xy2);
xlim([-10,45]);
xlabel('\alpha [deg]');
% ylabel('Cm_{-10\circ}');
ylabel('Cm');
title('Cm_\alpha for \delta_e= -10\circ');
grid

figure
xy3=pchip(alpha, Cm_0, alp);
plot(alpha,Cm_0,'*',alp,xy3);
xlim([-10,45]);
xlabel('\alpha [deg]');
% ylabel('Cm_{0\circ}');
ylabel('Cm');
title('Cm_\alpha for \delta_e= 0\circ');
grid

figure
xy4=pchip(alpha, Cm_10, alp);
plot(alpha,Cm_10,'*',alp,xy4);
xlim([-10,45]);
xlabel('\alpha [deg]');
% ylabel('Cm_{10\circ}');
ylabel('Cm');
title('Cm_\alpha for \delta_e= 10\circ');
grid

figure
xy5=pchip(alpha, Cm_25, alp);
plot(alpha,Cm_25,'*',alp,xy5);
xlim([-10,45]);
xlabel('\alpha [deg]');
% ylabel('Cm_{25\circ}');
ylabel('Cm');
title('Cm_\alpha for \delta_e= 25\circ');
grid

%-------------------------------------------------------

% figure
% subplot(5,1,1);
% plot(alpha, Cm_25_);
% xlim([-10,45]);
% xlabel('\alpha [deg]');
% ylabel('Cm_{-25\circ}');
% title('Pitching moment of F16 for constant elevator angles');
% grid
% 
% subplot(5,1,2);
% plot(alpha, Cm_10_);
% xlim([-10,45]);
% % xlabel('\alpha [deg]');
% ylabel('Cm_{-10\circ}');
% grid
% 
% subplot(5,1,3);
% plot(alpha, Cm_0);
% xlim([-10,45]);
% % xlabel('\alpha [deg]');
% ylabel('Cm_{0\circ}');
% grid
% 
% subplot(5,1,4);
% plot(alpha, Cm_10);
% xlim([-10,45]);
% % xlabel('\alpha [deg]');
% ylabel('Cm_{10\circ}');
% grid
% 
% subplot(5,1,5);
% plot(alpha, Cm_25);
% xlim([-10,45]);
% xlabel('\alpha [deg]');
% ylabel('Cm_{25\circ}');
% grid


