
% F16 sim plots
close all

% longitudinal stability

% disturbance of angle of attack
figure
plot(alpha_disturbance.time, alpha_disturbance.signals.values);
title('Constant disturbance of angle of attack \alpha');
xlabel('time [s]');
ylabel('\Delta_{\alpha} [deg]');
ylim([-0.5,2.5]);
grid

% positions
figure
subplot(2,1,1);
plot(positions_ned.time, positions_ned.signals(1,1).values)
title('Longitudinal positions in NED');
xlabel('time [s]');
ylabel('npos [ft]');
grid

subplot(2,1,2);
plot(positions_ned.time, positions_ned.signals(1,3).values)
xlabel('time [s]');
ylabel('altitude [ft]');
grid

% Attitude
figure
plot(attitude_phi_theta_psi.time, attitude_phi_theta_psi.signals(1,2).values)
title('Longitudinal Attitude');
xlabel('time [s]');
ylabel('\theta [deg]');
grid

% Wind/stability axes parameters 
figure
subplot(2,1,1);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,1).values)
title('Longitudinal wind/stability axes parameters');
xlabel('time [s]');
ylabel('Vel [ft/s]');
grid

subplot(2,1,2);
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,2).values)
xlabel('time [s]');
ylabel('\alpha [deg]');
grid

% Rotational rates
figure
plot(vel_alpha_beta.time, vel_alpha_beta.signals(1,1).values)
title('Longitudinal rotational rates, q ');
xlabel('time [s]');
ylabel('q [deg/s]');
grid


